Pipeline [tekton.dev/v1]
- Description
- Pipeline describes a list of Tasks to execute. It expresses how outputs of tasks feed into inputs of subsequent tasks.
- Type
object
Specification
.spec
- Description
- Spec holds the desired state of the Pipeline from the client
- Type
object
.spec.finally
- Description
- Finally declares the list of Tasks that execute just before leaving the Pipeline i.e. either after all Tasks are finished executing successfully or after a failure which would result in ending the Pipeline
- Type
array
.spec.finally[]
- Description
- PipelineTask defines a task in a Pipeline, passing inputs from both Params and from the output of previous tasks.
- Type
object
.spec.finally[].matrix
- Description
- Matrix declares parameters used to fan out this task.
- Type
object
.spec.finally[].matrix.include
- Description
- Include is a list of IncludeParams which allows passing in specific combinations of Parameters into the Matrix.
- Type
array
.spec.finally[].matrix.include[]
- Description
- IncludeParams allows passing in a specific combinations of Parameters into the Matrix.
- Type
object
.spec.finally[].matrix.include[].params
- Description
- Params takes only `Parameters` of type `"string"` The names of the `params` must match the names of the `params` in the underlying `Task`
- Type
array
.spec.finally[].matrix.include[].params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.finally[].matrix.params
- Description
- Params is a list of parameters used to fan out the pipelineTask Params takes only `Parameters` of type `"array"` Each array element is supplied to the `PipelineTask` by substituting `params` of type `"string"` in the underlying `Task`. The names of the `params` in the `Matrix` must match the names of the `params` in the underlying `Task` that they will be substituting.
- Type
array
.spec.finally[].matrix.params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.finally[].params
- Description
- Parameters declares parameters passed to this task.
- Type
array
.spec.finally[].params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.finally[].pipelineRef
- Description
- PipelineRef is a reference to a pipeline definition Note: PipelineRef is in preview mode and not yet supported
- Type
object
.spec.finally[].pipelineRef.params
- Description
- Params contains the parameters used to identify the referenced Tekton resource. Example entries might include "repo" or "path" but the set of params ultimately depends on the chosen resolver.
- Type
array
.spec.finally[].pipelineRef.params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.finally[].runAfter
- Description
- RunAfter is the list of PipelineTask names that should be executed before this Task executes. (Used to force a specific ordering in graph execution.)
- Type
array
.spec.finally[].runAfter[]
- Type
string
.spec.finally[].taskRef
- Description
- TaskRef is a reference to a task definition.
- Type
object
.spec.finally[].taskRef.params
- Description
- Params contains the parameters used to identify the referenced Tekton resource. Example entries might include "repo" or "path" but the set of params ultimately depends on the chosen resolver.
- Type
array
.spec.finally[].taskRef.params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.finally[].when
- Description
- When is a list of when expressions that need to be true for the task to run
- Type
array
.spec.finally[].when[]
- Description
- WhenExpression allows a PipelineTask to declare expressions to be evaluated before the Task is run to determine whether the Task should be executed or skipped
- Type
object
.spec.finally[].when[].values
- Description
- Values is an array of strings, which is compared against the input, for guard checking It must be non-empty
- Type
array
.spec.finally[].when[].values[]
- Type
string
.spec.finally[].workspaces
- Description
- Workspaces maps workspaces from the pipeline spec to the workspaces declared in the Task.
- Type
array
.spec.finally[].workspaces[]
- Description
- WorkspacePipelineTaskBinding describes how a workspace passed into the pipeline should be mapped to a task's declared workspace.
- Type
object- Required
name
.spec.params
- Description
- Params declares a list of input parameters that must be supplied when this Pipeline is run.
- Type
array
.spec.params[]
- Description
- ParamSpec defines arbitrary parameters needed beyond typed inputs (such as resources). Parameter values are provided by users as inputs on a TaskRun or PipelineRun.
- Type
object- Required
name
.spec.params[].enum
- Description
- Enum declares a set of allowed param input values for tasks/pipelines that can be validated. If Enum is not set, no input validation is performed for the param.
- Type
array
.spec.params[].enum[]
- Type
string
.spec.params[].properties
- Description
- Properties is the JSON Schema properties to support key-value pairs parameter.
- Type
object
.spec.results
- Description
- Results are values that this pipeline can output once run
- Type
array
.spec.results[]
- Description
- PipelineResult used to describe the results of a pipeline
- Type
object- Required
namevalue
.spec.tasks
- Description
- Tasks declares the graph of Tasks that execute when this Pipeline is run.
- Type
array
.spec.tasks[]
- Description
- PipelineTask defines a task in a Pipeline, passing inputs from both Params and from the output of previous tasks.
- Type
object
.spec.tasks[].matrix
- Description
- Matrix declares parameters used to fan out this task.
- Type
object
.spec.tasks[].matrix.include
- Description
- Include is a list of IncludeParams which allows passing in specific combinations of Parameters into the Matrix.
- Type
array
.spec.tasks[].matrix.include[]
- Description
- IncludeParams allows passing in a specific combinations of Parameters into the Matrix.
- Type
object
.spec.tasks[].matrix.include[].params
- Description
- Params takes only `Parameters` of type `"string"` The names of the `params` must match the names of the `params` in the underlying `Task`
- Type
array
.spec.tasks[].matrix.include[].params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.tasks[].matrix.params
- Description
- Params is a list of parameters used to fan out the pipelineTask Params takes only `Parameters` of type `"array"` Each array element is supplied to the `PipelineTask` by substituting `params` of type `"string"` in the underlying `Task`. The names of the `params` in the `Matrix` must match the names of the `params` in the underlying `Task` that they will be substituting.
- Type
array
.spec.tasks[].matrix.params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.tasks[].params
- Description
- Parameters declares parameters passed to this task.
- Type
array
.spec.tasks[].params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.tasks[].pipelineRef
- Description
- PipelineRef is a reference to a pipeline definition Note: PipelineRef is in preview mode and not yet supported
- Type
object
.spec.tasks[].pipelineRef.params
- Description
- Params contains the parameters used to identify the referenced Tekton resource. Example entries might include "repo" or "path" but the set of params ultimately depends on the chosen resolver.
- Type
array
.spec.tasks[].pipelineRef.params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.tasks[].runAfter
- Description
- RunAfter is the list of PipelineTask names that should be executed before this Task executes. (Used to force a specific ordering in graph execution.)
- Type
array
.spec.tasks[].runAfter[]
- Type
string
.spec.tasks[].taskRef
- Description
- TaskRef is a reference to a task definition.
- Type
object
.spec.tasks[].taskRef.params
- Description
- Params contains the parameters used to identify the referenced Tekton resource. Example entries might include "repo" or "path" but the set of params ultimately depends on the chosen resolver.
- Type
array
.spec.tasks[].taskRef.params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.tasks[].when
- Description
- When is a list of when expressions that need to be true for the task to run
- Type
array
.spec.tasks[].when[]
- Description
- WhenExpression allows a PipelineTask to declare expressions to be evaluated before the Task is run to determine whether the Task should be executed or skipped
- Type
object
.spec.tasks[].when[].values
- Description
- Values is an array of strings, which is compared against the input, for guard checking It must be non-empty
- Type
array
.spec.tasks[].when[].values[]
- Type
string
.spec.tasks[].workspaces
- Description
- Workspaces maps workspaces from the pipeline spec to the workspaces declared in the Task.
- Type
array
.spec.tasks[].workspaces[]
- Description
- WorkspacePipelineTaskBinding describes how a workspace passed into the pipeline should be mapped to a task's declared workspace.
- Type
object- Required
name
.spec.workspaces
- Description
- Workspaces declares a set of named workspaces that are expected to be provided by a PipelineRun.
- Type
array
.spec.workspaces[]
- Description
- PipelineWorkspaceDeclaration creates a named slot in a Pipeline that a PipelineRun is expected to populate with a workspace binding.
- Type
object- Required
name
API Endpoints
The following API endpoints are available:
/apis/tekton.dev/v1/namespaces/{namespace}/pipelinesDELETE: delete collection of PipelineGET: list objects of kind PipelinePOST: create a new Pipeline
/apis/tekton.dev/v1/namespaces/{namespace}/pipelines/{name}DELETE: delete the specified PipelineGET: read the specified PipelinePATCH: partially update the specified PipelinePUT: replace the specified Pipeline
/apis/tekton.dev/v1/namespaces/{namespace}/pipelines
- HTTP method
DELETE- Description
- delete collection of Pipeline
- HTTP responses
- HTTP method
GET- Description
- list objects of kind Pipeline
- HTTP responses
- HTTP method
POST- Description
- create a new Pipeline
- Query parameters
- Body parameters
- HTTP responses
/apis/tekton.dev/v1/namespaces/{namespace}/pipelines/{name}
- HTTP method
DELETE- Description
- delete the specified Pipeline
- Query parameters
- HTTP responses
- HTTP method
GET- Description
- read the specified Pipeline
- HTTP responses
- HTTP method
PATCH- Description
- partially update the specified Pipeline
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace the specified Pipeline
- Query parameters
- Body parameters
- HTTP responses